pub use crate::api::Torrent;

#[derive(Clone, Serialize, Deserialize)]
pub struct TorrentList(Vec<Torrent>);

impl TorrentList {
    pub fn new() -> TorrentList {
        TorrentList(Vec::new())
    }

    pub fn push(&mut self, entry: Torrent) {
        self.0.push(entry);
    }

    pub fn to_vec(self) -> Vec<Torrent> {
        self.0
    }
}

impl IntoIterator for TorrentList {
    type Item = Torrent;
    type IntoIter = std::vec::IntoIter<Self::Item>;

    fn into_iter(self) -> Self::IntoIter {
        self.0.into_iter()
    }
}

impl FromIterator<Torrent> for TorrentList {
    fn from_iter<I: IntoIterator<Item=Torrent>>(iter: I) -> Self {
        let mut c = TorrentList::new();

        for i in iter {
            c.push(i);
        }

        c
    }
}
